var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import * as React from 'react';
import PropTypes from 'prop-types';
import Portal from '../Portal';
import Transition from '../Transition';
import ClickOutside from '../ClickOutside';
import emptyFunction from '../utils/emptyFunction';
import { BackdropContainer, Container } from './Components';

var Dialog = function Dialog(_ref) {
  var show = _ref.show,
      children = _ref.children,
      onOutsideClick = _ref.onOutsideClick,
      backdropTransition = _ref.backdropTransition,
      containerTransition = _ref.containerTransition;
  return show && React.createElement(
    React.Fragment,
    null,
    React.createElement(
      Portal,
      null,
      React.createElement(Transition, _extends({ component: BackdropContainer }, backdropTransition))
    ),
    React.createElement(
      Portal,
      null,
      React.createElement(
        Container,
        null,
        React.createElement(
          ClickOutside,
          { onClick: onOutsideClick },
          React.createElement(
            Transition,
            _extends({ component: false }, containerTransition),
            children
          )
        )
      )
    )
  );
};

Dialog.propTypes = process.env.NODE_ENV !== "production" ? {
  show: PropTypes.bool,
  children: PropTypes.node.isRequired,
  onOutsideClick: PropTypes.func,
  backdropTransition: PropTypes.any,
  containerTransition: PropTypes.any
} : {};
Dialog.defaultProps = {
  show: false,
  onOutsideClick: emptyFunction,
  backdropTransition: {
    style: {
      opacity: 0.3
    },
    animation: {
      ease: 'easeOutCubic',
      duration: 200,
      delay: 0,
      opacity: 1
    }
  },
  containerTransition: {
    style: {
      transform: 'translateY(-20px)'
    },
    animation: {
      ease: 'easeOutQuart',
      duration: 200,
      delay: 0,
      translateY: 0
    }
  }
};

export default Dialog;