var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import * as React from 'react';
import * as R from 'ramda';
import PropTypes from 'prop-types';
import Transition from '../Transition';
import Portal from '../Portal';
import DomAlign from '../DomAlign';
import ClickOutside from '../ClickOutside';
import emptyFunction from '../utils/emptyFunction';

var Overlay = (_temp2 = _class = function (_React$Component) {
  _inherits(Overlay, _React$Component);

  function Overlay() {
    var _temp, _this, _ret;

    _classCallCheck(this, Overlay);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.onOutsideClick = function (e) {
      var _this$props = _this.props,
          target = _this$props.target,
          onOutsideClick = _this$props.onOutsideClick;

      if (target.current && target.current.contains(e.target)) return; // Note: Omit clicking target.

      if (onOutsideClick) {
        onOutsideClick(e);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Overlay.prototype.render = function render() {
    var _props = this.props,
        show = _props.show,
        alignConfig = _props.alignConfig,
        target = _props.target,
        transitionConfig = _props.transitionConfig,
        children = _props.children,
        resize = _props.resize,
        style = _props.style,
        otherProps = _objectWithoutProperties(_props, ['show', 'alignConfig', 'target', 'transitionConfig', 'children', 'resize', 'style']);

    var onOutsideClick = this.onOutsideClick;


    return show && React.createElement(
      Portal,
      null,
      React.createElement(
        ClickOutside,
        { onClick: onOutsideClick },
        React.createElement(
          DomAlign,
          {
            config: _extends({}, alignConfig),
            target: target,
            resize: resize
          },
          React.createElement(
            'div',
            _extends({
              style: _extends({ position: 'absolute' }, style)
            }, R.omit(['onOutsideClick'])(otherProps)),
            React.createElement(
              Transition,
              _extends({}, transitionConfig, { component: false }),
              children
            )
          )
        )
      )
    );
  };

  return Overlay;
}(React.Component), _class.defaultProps = {
  show: false,
  onOutsideClick: emptyFunction,
  alignConfig: {
    points: ['tr', 'br'], // bottom-right
    offset: [0, 0]
  },
  transitionConfig: {
    // From
    style: {
      opacity: 0
    },
    // To
    animation: {
      opacity: 1
    }
  },
  resize: false
}, _temp2);
Overlay.propTypes = process.env.NODE_ENV !== "production" ? {
  show: PropTypes.bool,
  children: PropTypes.node.isRequired,
  onOutsideClick: PropTypes.func, // Note: for root close
  target: PropTypes.object,
  alignConfig: PropTypes.object, // docs: https://github.com/yiminghe/dom-align#alignconfig-object-details
  transitionConfig: PropTypes.object, // docs: https://github.com/react-component/tween-one
  resize: PropTypes.bool
} : {};


export default Overlay;