'use strict';

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _react2 = require('@storybook/react');

var _addonActions = require('@storybook/addon-actions');

var _ = require('.');

var _2 = _interopRequireDefault(_);

var _Overlay = require('../Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint react/no-multi-comp: 0 */


var MenuOverlay = function (_React$Component) {
  _inherits(MenuOverlay, _React$Component);

  function MenuOverlay() {
    var _temp, _this, _ret;

    _classCallCheck(this, MenuOverlay);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = { show: false }, _this.target = React.createRef(), _this.onClick = function () {
      return _this.setState(function (_ref) {
        var show = _ref.show;
        return { show: !show };
      });
    }, _this.onHide = function () {
      return _this.setState({ show: false });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  MenuOverlay.prototype.render = function render() {
    var show = this.state.show;
    var onClick = this.onClick,
        onHide = this.onHide,
        target = this.target;
    var menuRef = this.props.menuRef;


    return React.createElement(
      'div',
      null,
      React.createElement(
        'div',
        {
          ref: target,
          onClick: onClick,
          onKeyPress: onClick,
          style: { backgroundColor: 'antiquewhite' }
        },
        'Click me'
      ),
      React.createElement(
        _Overlay2.default,
        { show: show, target: target, onOutsideClick: onHide },
        React.createElement(
          'div',
          {
            key: 'menu',
            ref: menuRef,
            style: { width: 300, backgroundColor: 'aliceblue' }
          },
          React.createElement(
            'div',
            { onClick: (0, _addonActions.action)('click 1'), onKeyPress: (0, _addonActions.action)('click 1') },
            'Item 1'
          ),
          React.createElement(
            'div',
            { onClick: (0, _addonActions.action)('click 2'), onKeyPress: (0, _addonActions.action)('click 2') },
            'Item 2'
          )
        )
      )
    );
  };

  return MenuOverlay;
}(React.Component);

var StatefulDialog = function (_React$Component2) {
  _inherits(StatefulDialog, _React$Component2);

  function StatefulDialog() {
    var _temp2, _this2, _ret2;

    _classCallCheck(this, StatefulDialog);

    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return _ret2 = (_temp2 = (_this2 = _possibleConstructorReturn(this, _React$Component2.call.apply(_React$Component2, [this].concat(args))), _this2), _this2.state = { show: false }, _this2.overlay = React.createRef(), _this2.onClick = function () {
      return _this2.setState(function (_ref2) {
        var show = _ref2.show;
        return { show: !show };
      });
    }, _this2.onHide = function (e) {
      var overlay = _this2.overlay.current;
      // Hint: Omit clicking overlay.
      if (overlay && overlay.contains(e.target)) return; // Node: Omit clicking itself.
      _this2.setState({ show: false });
    }, _temp2), _possibleConstructorReturn(_this2, _ret2);
  }

  StatefulDialog.prototype.render = function render() {
    var show = this.state.show;
    var containerTransition = this.props.containerTransition;
    var overlay = this.overlay,
        onClick = this.onClick,
        onHide = this.onHide;


    return React.createElement(
      'div',
      null,
      React.createElement(
        'span',
        {
          onClick: onClick,
          onKeyPress: onClick,
          style: { backgroundColor: 'antiquewhite' }
        },
        'Open dialog'
      ),
      React.createElement(
        _2.default,
        {
          show: show,
          onOutsideClick: onHide,
          containerTransition: containerTransition
        },
        React.createElement(
          'div',
          { key: 'div', style: { width: 300, backgroundColor: 'aliceblue' } },
          'This is content.',
          React.createElement(MenuOverlay, { menuRef: overlay })
        )
      )
    );
  };

  return StatefulDialog;
}(React.Component);

(0, _react2.storiesOf)('Dialog', module).add('API', function () {
  return React.createElement(StatefulDialog, null);
}, {
  info: {
    text: 'Basic',
    inline: true,
    propTables: [_2.default]
  }
}).add('Custom transition', function () {
  return React.createElement(StatefulDialog, {
    containerTransition: {
      style: {
        transform: 'translateY(20px)'
      },
      animation: {
        ease: 'easeOutBounce',
        duration: 200,
        delay: 0,
        translateY: 40
      }
    }
  });
}, {
  info: {
    text: 'with containerTransition props',
    inline: true,
    propTables: [_2.default]
  }
});