'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Portal = require('../Portal');

var _Portal2 = _interopRequireDefault(_Portal);

var _Transition = require('../Transition');

var _Transition2 = _interopRequireDefault(_Transition);

var _ClickOutside = require('../ClickOutside');

var _ClickOutside2 = _interopRequireDefault(_ClickOutside);

var _emptyFunction = require('../utils/emptyFunction');

var _emptyFunction2 = _interopRequireDefault(_emptyFunction);

var _Components = require('./Components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var Dialog = function Dialog(_ref) {
  var show = _ref.show,
      children = _ref.children,
      onOutsideClick = _ref.onOutsideClick,
      backdropTransition = _ref.backdropTransition,
      containerTransition = _ref.containerTransition;
  return show && React.createElement(
    React.Fragment,
    null,
    React.createElement(
      _Portal2.default,
      null,
      React.createElement(_Transition2.default, _extends({ component: _Components.BackdropContainer }, backdropTransition))
    ),
    React.createElement(
      _Portal2.default,
      null,
      React.createElement(
        _Components.Container,
        null,
        React.createElement(
          _ClickOutside2.default,
          { onClick: onOutsideClick },
          React.createElement(
            _Transition2.default,
            _extends({ component: false }, containerTransition),
            children
          )
        )
      )
    )
  );
};

Dialog.propTypes = process.env.NODE_ENV !== "production" ? {
  show: _propTypes2.default.bool,
  children: _propTypes2.default.node.isRequired,
  onOutsideClick: _propTypes2.default.func,
  backdropTransition: _propTypes2.default.any,
  containerTransition: _propTypes2.default.any
} : {};
Dialog.defaultProps = {
  show: false,
  onOutsideClick: _emptyFunction2.default,
  backdropTransition: {
    style: {
      opacity: 0.3
    },
    animation: {
      ease: 'easeOutCubic',
      duration: 200,
      delay: 0,
      opacity: 1
    }
  },
  containerTransition: {
    style: {
      transform: 'translateY(-20px)'
    },
    animation: {
      ease: 'easeOutQuart',
      duration: 200,
      delay: 0,
      translateY: 0
    }
  }
};

exports.default = Dialog;
module.exports = exports['default'];