'use strict';

exports.__esModule = true;

var _class, _temp2; /* global window */


var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _domAlign = require('dom-align');

var _domAlign2 = _interopRequireDefault(_domAlign);

var _rafThrottle = require('raf-throttle');

var _rafThrottle2 = _interopRequireDefault(_rafThrottle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DomAlign = (_temp2 = _class = function (_React$Component) {
  _inherits(DomAlign, _React$Component);

  function DomAlign() {
    var _temp, _this, _ret;

    _classCallCheck(this, DomAlign);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.source = React.createRef(), _this.align = (0, _rafThrottle2.default)(function () {
      var _this$props = _this.props,
          target = _this$props.target,
          config = _this$props.config;
      var _this2 = _this,
          source = _this2.source;


      if (target && target.current && source && source.current) {
        // Note: Wait for two react instance ready.
        (0, _domAlign2.default)(source.current, target.current, config);
      }
    }), _temp), _possibleConstructorReturn(_this, _ret);
  }

  DomAlign.prototype.componentDidMount = function componentDidMount() {
    var resize = this.props.resize;

    this.align();
    if (resize) {
      window.addEventListener('resize', this.align);
      window.addEventListener('scroll', this.align);
      window.addEventListener('wheel', this.align);
    }
  };

  DomAlign.prototype.componentDidUpdate = function componentDidUpdate() {
    var _this3 = this;

    // TODO: make it async. there is a problem of overlay in dialog case.
    this.timeoutId = setTimeout(function () {
      return _this3.align();
    });
  };

  DomAlign.prototype.componentWillUnmount = function componentWillUnmount() {
    var resize = this.props.resize;

    if (resize) {
      window.removeEventListener('resize', this.align);
      window.removeEventListener('scroll', this.align);
      window.removeEventListener('wheel', this.align);
    }
    if (this.align && this.align.cancel) this.align.cancel();
    if (this.timeoutId) clearTimeout(this.timeoutId);
  };

  DomAlign.prototype.render = function render() {
    var children = this.props.children;
    var source = this.source;


    return React.cloneElement(React.Children.only(children), {
      ref: source
    });
  };

  return DomAlign;
}(React.Component), _class.defaultProps = {
  target: undefined,
  resize: false
}, _temp2);
DomAlign.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.element.isRequired,
  config: _propTypes2.default.object.isRequired,
  target: _propTypes2.default.object,
  resize: _propTypes2.default.bool
} : {};
exports.default = DomAlign;
module.exports = exports['default'];