'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _react2 = require('@storybook/react');

var _addonActions = require('@storybook/addon-actions');

var _ = require('.');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint react/no-multi-comp: 0 */


var BasicOverlay = function (_React$Component) {
  _inherits(BasicOverlay, _React$Component);

  function BasicOverlay() {
    var _temp, _this, _ret;

    _classCallCheck(this, BasicOverlay);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = { show: true }, _this.target = React.createRef(), _this.onMouseEnter = function () {
      return _this.setState(function (_ref) {
        var show = _ref.show;
        return { show: !show };
      });
    }, _this.onHide = function () {
      return _this.setState({ show: false });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  BasicOverlay.prototype.render = function render() {
    var show = this.state.show;
    var onMouseEnter = this.onMouseEnter,
        onHide = this.onHide,
        target = this.target;


    return React.createElement(
      'div',
      null,
      React.createElement(
        'span',
        {
          ref: target,
          onMouseEnter: onMouseEnter,
          onMouseLeave: onHide,
          style: { backgroundColor: 'antiquewhite' }
        },
        'Hover me'
      ),
      React.createElement(
        _2.default,
        _extends({ show: show, target: target }, this.props),
        React.createElement(
          'div',
          { key: 'div', style: { width: 300, backgroundColor: 'aliceblue' } },
          'This is overlay content.'
        )
      )
    );
  };

  return BasicOverlay;
}(React.Component);

var MenuOverlay = function (_React$Component2) {
  _inherits(MenuOverlay, _React$Component2);

  function MenuOverlay() {
    var _temp2, _this2, _ret2;

    _classCallCheck(this, MenuOverlay);

    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return _ret2 = (_temp2 = (_this2 = _possibleConstructorReturn(this, _React$Component2.call.apply(_React$Component2, [this].concat(args))), _this2), _this2.state = { show: false }, _this2.target = React.createRef(), _this2.onClick = function () {
      return _this2.setState(function (_ref2) {
        var show = _ref2.show;
        return { show: !show };
      });
    }, _this2.onHide = function () {
      return _this2.setState({ show: false });
    }, _temp2), _possibleConstructorReturn(_this2, _ret2);
  }

  MenuOverlay.prototype.render = function render() {
    var show = this.state.show;
    var onClick = this.onClick,
        onHide = this.onHide,
        target = this.target;


    return React.createElement(
      'div',
      null,
      React.createElement(
        'div',
        {
          ref: target,
          onClick: onClick,
          onKeyPress: onClick,
          style: { backgroundColor: 'antiquewhite' }
        },
        'Click me'
      ),
      React.createElement(
        _2.default,
        _extends({
          show: show,
          target: target,
          onOutsideClick: onHide
        }, this.props),
        React.createElement(
          'div',
          { key: 'menu', style: { width: 300, backgroundColor: 'aliceblue' } },
          React.createElement(
            'div',
            { onClick: (0, _addonActions.action)('click 1'), onKeyPress: (0, _addonActions.action)('click 1') },
            'Item 1'
          ),
          React.createElement(
            'div',
            { onClick: (0, _addonActions.action)('click 2'), onKeyPress: (0, _addonActions.action)('click 2') },
            'Item 2'
          )
        )
      )
    );
  };

  return MenuOverlay;
}(React.Component);

(0, _react2.storiesOf)('Overlay', module).add('Basic', function () {
  return React.createElement(BasicOverlay, { alignConfig: { points: ['cl', 'cr'], offset: [5, 0] } });
}, {
  info: {
    text: 'state = { show: true }',
    inline: true,
    propTables: [_2.default]
  }
}).add('Dropdown', function () {
  return React.createElement(
    'div',
    {
      style: {
        display: 'flex',
        justifyContent: 'space-between'
      }
    },
    React.createElement(MenuOverlay, {
      alignConfig: { points: ['tl', 'bl'], offset: [0, 0] },
      transitionConfig: {
        animation: {
          translateY: 0,
          opacity: 1
        },
        style: {
          transform: 'translateY(-10px)',
          opacity: 0
        }
      }
    }),
    React.createElement(MenuOverlay, {
      alignConfig: { points: ['tc', 'bc'], offset: [0, 0] },
      transitionConfig: {
        animation: {
          translateX: 0,
          translateY: 0,
          ease: 'easeOutBounce',
          duration: 600
        },
        style: {
          transform: 'translate(-20px, -20px)'
        }
      }
    }),
    React.createElement(MenuOverlay, {
      resize: true,
      alignConfig: { points: ['cr', 'cl'], offset: [-8, 0] },
      transitionConfig: {
        style: {
          transform: 'translateX(8px)'
        },
        animation: {
          translateX: 0,
          ease: 'easeOutQuart'
        }
      }
    })
  );
}, {
  info: {
    text: 'With onHide function for rootClose',
    inline: true,
    propTables: [_2.default]
  }
});