'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _ramda = require('ramda');

var R = _interopRequireWildcard(_ramda);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Transition = require('../Transition');

var _Transition2 = _interopRequireDefault(_Transition);

var _Portal = require('../Portal');

var _Portal2 = _interopRequireDefault(_Portal);

var _DomAlign = require('../DomAlign');

var _DomAlign2 = _interopRequireDefault(_DomAlign);

var _ClickOutside = require('../ClickOutside');

var _ClickOutside2 = _interopRequireDefault(_ClickOutside);

var _emptyFunction = require('../utils/emptyFunction');

var _emptyFunction2 = _interopRequireDefault(_emptyFunction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Overlay = (_temp2 = _class = function (_React$Component) {
  _inherits(Overlay, _React$Component);

  function Overlay() {
    var _temp, _this, _ret;

    _classCallCheck(this, Overlay);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.onOutsideClick = function (e) {
      var _this$props = _this.props,
          target = _this$props.target,
          onOutsideClick = _this$props.onOutsideClick;

      if (target.current && target.current.contains(e.target)) return; // Note: Omit clicking target.

      if (onOutsideClick) {
        onOutsideClick(e);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Overlay.prototype.render = function render() {
    var _props = this.props,
        show = _props.show,
        alignConfig = _props.alignConfig,
        target = _props.target,
        transitionConfig = _props.transitionConfig,
        children = _props.children,
        resize = _props.resize,
        style = _props.style,
        otherProps = _objectWithoutProperties(_props, ['show', 'alignConfig', 'target', 'transitionConfig', 'children', 'resize', 'style']);

    var onOutsideClick = this.onOutsideClick;


    return show && React.createElement(
      _Portal2.default,
      null,
      React.createElement(
        _ClickOutside2.default,
        { onClick: onOutsideClick },
        React.createElement(
          _DomAlign2.default,
          {
            config: _extends({}, alignConfig),
            target: target,
            resize: resize
          },
          React.createElement(
            'div',
            _extends({
              style: _extends({ position: 'absolute' }, style)
            }, R.omit(['onOutsideClick'])(otherProps)),
            React.createElement(
              _Transition2.default,
              _extends({}, transitionConfig, { component: false }),
              children
            )
          )
        )
      )
    );
  };

  return Overlay;
}(React.Component), _class.defaultProps = {
  show: false,
  onOutsideClick: _emptyFunction2.default,
  alignConfig: {
    points: ['tr', 'br'], // bottom-right
    offset: [0, 0]
  },
  transitionConfig: {
    // From
    style: {
      opacity: 0
    },
    // To
    animation: {
      opacity: 1
    }
  },
  resize: false
}, _temp2);
Overlay.propTypes = process.env.NODE_ENV !== "production" ? {
  show: _propTypes2.default.bool,
  children: _propTypes2.default.node.isRequired,
  onOutsideClick: _propTypes2.default.func, // Note: for root close
  target: _propTypes2.default.object,
  alignConfig: _propTypes2.default.object, // docs: https://github.com/yiminghe/dom-align#alignconfig-object-details
  transitionConfig: _propTypes2.default.object, // docs: https://github.com/react-component/tween-one
  resize: _propTypes2.default.bool
} : {};
exports.default = Overlay;
module.exports = exports['default'];